%{
===========================================================================
Code provided by Yichuan (Charlie) Tang
Permission is granted for anyone to copy, use, modify, or distribute this
program and accompanying programs and documents for any purpose, provided
this copyright notice is retained and prominently displayed, along with
a note saying that the original programs are available from our
web page.
The programs and documents are distributed without any warranty, express or
implied.  As the programs were written for research purposes only, they 
have not been tested to the degree that would be advisable in any important
application.  All use of these programs is entirely at the user's own risk.
===========================================================================

CT 3/2012 
multiplies a matriczied tensor T [D x (d1 * d2)] with a matrix z1 of d1 by N
returns matrices W = [ D x d2 x N ]
%}
function [W] = TensorMatrixProd_z1(T, d1, d2, z1)

D = size(T,1);
N = size(z1,2);
assert(size(T,2) == d1*d2);
assert(size(z1,1) == d1);

TT = tensor(reshape(T, [D, d1, d2]),[D d1 d2]); %easier to use tensor matrix product
temp = ttm(TT, z1', 2);                %multiply z1 (which is mode 2)
mat = tenmat(temp, [1 3]);            % sort of shift the dimensions (from D x N x d2), since we want N to be 3rd dimension
W = reshape(mat.data, [D, d2, N]);    % reshape so we have D x d2 x N