%{

===========================================================================
Code provided by Yichuan (Charlie) Tang
Permission is granted for anyone to copy, use, modify, or distribute this
program and accompanying programs and documents for any purpose, provided
this copyright notice is retained and prominently displayed, along with
a note saying that the original programs are available from our
web page.
The programs and documents are distributed without any warranty, express or
implied.  As the programs were written for research purposes only, they 
have not been tested to the degree that would be advisable in any important
application.  All use of these programs is entirely at the user's own risk.
===========================================================================

CT 3/2012 
multiplies a matriczied tensor T [D x (d1 * d2)] with a matrix of d2 by N
returns matrices W = [ D x d1 x N ]
z2 - d2 by N

output:
W D by d1 by N cube of weights
%}
function [W] = TensorMatrixProd_z2(T, d1, d2, z2)

D = size(T, 1);
N = size(z2, 2);
assert(size(T,2) == d1*d2);
assert(size(z2,1) == d2);

TT = reshape(T, D*d1, d2);
W = TT*z2;
W = reshape(W, [D, d1, N]);

