%{
===========================================================================
Code provided by Yichuan (Charlie) Tang
Permission is granted for anyone to copy, use, modify, or distribute this
program and accompanying programs and documents for any purpose, provided
this copyright notice is retained and prominently displayed, along with
a note saying that the original programs are available from our
web page.
The programs and documents are distributed without any warranty, express or
implied.  As the programs were written for research purposes only, they 
have not been tested to the degree that would be advisable in any important
application.  All use of these programs is entirely at the user's own risk.
===========================================================================

CT 5/2012 

%difference from TensorMatrixProd_zs in that we multiply all zs into the
tensor, instead of leaving one dimension "thisind"

% able to work with any number of z's
multiplies a matriczied tensor T [D x (d1 * d2 * d3 ...)] with a matrices zs{k} of d(k) by N
returns matrices W = [ D x N ]

d: dimensionality = [d1=2 d2=5 d3=10]
zs{1:d3} is a cell, each cell has dim by N samples, from one component

%}
function [W] = TensorMatrixProd_zs_all(T, d, zs)

D = size(T,1);
N = size(zs{1},2);
assert(size(T,2) == prod(d) );

TT = tensor(reshape(T, [D, d]),[D d]); %easier to use tensor matrix product

temp = ttm(TT, zs{end}', length(d)+1); %multiply highest mode's data
highest_mode = length(d)+1;

for i = length(d)-1:-1:1
    mode = i+1;  %+1 since TT's mode-1 is D
    
    reshapeinds = ones(1, length(d)+1);
    reshapeinds(mode) = size(zs{i},1);
    reshapeinds(highest_mode) = size(zs{i},2);        
    temp2 = reshape(zs{i}, reshapeinds);
    
    repmatinds = size(temp);
	repmatinds(mode)=1;
    repmatinds(highest_mode) = 1;
    
    temp2 = repmat(temp2, repmatinds);
    temp = tensor( sum(temp2.*temp.data, mode) );
end
temp = tensor( squeeze(temp.data ) );
W = double(temp.data);


