%{
===========================================================================
Code provided by Yichuan (Charlie) Tang
Permission is granted for anyone to copy, use, modify, or distribute this
program and accompanying programs and documents for any purpose, provided
this copyright notice is retained and prominently displayed, along with
a note saying that the original programs are available from our
web page.
The programs and documents are distributed without any warranty, express or
implied.  As the programs were written for research purposes only, they 
have not been tested to the degree that would be advisable in any important
application.  All use of these programs is entirely at the user's own risk.
===========================================================================

CT 3/2012 - Sampling from a Mixture of Tensor Analyzer

z - {C by d's} cell, z{1,1} = d1 by N samples
N - number of samples
d_sample ( which latent group to sample, starting at 1)
noise - 1 means we want to add noise, 0 means otherwise    
%}


use mta3_cond_zs instead !!

function [xx] = sample_mta_given_zs( MoTA, z, N, d_sample, noise)

if nargin < 5
    noise=0;
end

D = size(MoTA.M,1);
C = length(MoTA.mix);

cc = rand(N,1);
cc = sum(cc*ones(1,C) > ones(N,1)*cumsum([0 MoTA.mix(1:end-1)']), 2);

xx = zeros(D,N);

for c=1:C;

    ii = find(cc==c);
    n  = length(ii);
    
    z1_samples = z1(ii,:);
    
    W1W2  = MoTA.W(:,:,c);
    Psi   = MoTA.Psi(:,c);
    
    for nn = 1:n
        
        z1_this = z1_samples(nn,:)';        
        W = bsxfun(@plus, W1W2(:,d1+1:end), TensorMatrixProd_z1( MoTA.T(:,:,c), d1,d2, z1_this));
        m = bsxfun(@plus, MoTA.M(:,c), W1W2(:,1:d1)*z1_this);
        
        yy = 1*randn(d2,1); % sample factors
        
        xx(:, ii(nn) ) = m+W*yy + noise*spdiags( Psi.^(1/2),0,D,D)*randn(D,1);        
    end    
end












